#!/bin/bash

#script écrit par Philippe Hénaff
#licence creatice commons CC BY-NC-SA 2.0 FR

#################################################
#declaration des variables globales
#################################################

###### variables pour les fichiers
nom_fichier_params_niveau1="/usr/share/BNE-Linux/params/configNiveau1.rc"
nom_fichier_params_niveau1_sauve="/usr/share/BNE-Linux/params/sauve_config/configNiveau1.rc"
nom_fichier_params_niveau2="/usr/share/BNE-Linux/params/configNiveau2.rc"
nom_fichier_params_niveau2_sauve="/usr/share/BNE-Linux/params/sauve_config/configNiveau2.rc"
nom_fichier_params_niveauAccueil="/usr/share/BNE-Linux/params/configAccueil.rc"
nom_fichier_params_niveauAccueil_sauve="/usr/share/BNE-Linux/params/sauve_config/configAccueil.rc"


#************************************************
#Fonction supprimer rubrique ou commande du BNE
#************************************************
supp_bouton_BNE_niveau1(){
# supprime l entree (bouton) du BNE (rubrique ou commande) contenant la chaine a trouver 
# $1 -> chaine a trouver dans la rubrique ou la commande -> exemple : ".*xdg-open smb.*"
# REMARQUE : eviter les caracteres speciaux tels que /
chaine_a_trouver_pour_suppression=".*39.*""${1}"".*"
	if [ -f "$nom_fichier_params_niveau1" ];then
		sudo sed -in "/${chaine_a_trouver_pour_suppression}/d" "$nom_fichier_params_niveau1"
		sudo sed -in "/${chaine_a_trouver_pour_suppression}/d" "$nom_fichier_params_niveau1_sauve"
	fi
}

supp_bouton_BNE_niveau2(){
# supprime l entree (bouton) du BNE (rubrique ou commande) contenant la chaine a trouver 
# $1 -> chaine a trouver dans la rubrique ou la commande -> exemple : "xdg-open smb"
chaine_a_trouver_pour_suppression=".*39.*""${1}"".*"
# REMARQUE : eviter les caracteres speciaux tels que /
	if [ -f "$nom_fichier_params_niveau2" ];then
		sudo sed -in "/${chaine_a_trouver_pour_suppression}/d" "$nom_fichier_params_niveau2"
		sudo sed -in "/${chaine_a_trouver_pour_suppression}/d" "$nom_fichier_params_niveau2_sauve"
	fi
}

supp_bouton_BNE_accueil(){
# supprime l entree (bouton) du BNE (rubrique ou commande) contenant la chaine a trouver 
# $1 -> chaine a trouver dans la rubrique ou la commande -> exemple : "xdg-open smb"
chaine_a_trouver_pour_suppression=".*39.*""${1}"".*"
# REMARQUE : eviter les caracteres speciaux tels que /
	if [ -f "$nom_fichier_params_niveauAccueil" ];then
		sudo sed -in "/${chaine_a_trouver_pour_suppression}/d" "$nom_fichier_params_niveauAccueil"
		sudo sed -in "/${chaine_a_trouver_pour_suppression}/d" "$nom_fichier_params_niveauAccueil_sauve"
	fi
}


#************************************************
#desinstallation du paquet DEBIAN
#************************************************
suppression_paquet_debian(){
	sudo dpkg -r BNE-logiciels-gratuits 
}

#************************************************
#installation des icones du BNE
#************************************************
suppression_bouton_BNE(){
	supp_bouton_BNE_niveau2 "Abacalc"
	supp_bouton_BNE_niveau2 "Abalect"
	supp_bouton_BNE_niveau1 "A la bonne"
	supp_bouton_BNE_niveau1 "campagne"
	supp_bouton_BNE_niveau1 "A la poste"
	supp_bouton_BNE_niveau2 "AtouMath"
	supp_bouton_BNE_niveau1 "Au jardin"
	supp_bouton_BNE_niveau2 "Calcul"
	supp_bouton_BNE_niveau2 "Calculatrice"
	supp_bouton_BNE_niveau1 "Cursouris"
	supp_bouton_BNE_niveau2 "Décimo"
	supp_bouton_BNE_niveau1 "Déplacements"
	supp_bouton_BNE_niveau1 "Domino"
	supp_bouton_BNE_niveau1 "Double entrée"
	supp_bouton_BNE_niveau2 "Fractions 1"
	supp_bouton_BNE_niveau2 "Fractions 2"
	supp_bouton_BNE_niveau2 "Je compte"
	supp_bouton_BNE_niveau1 "Labyrinthes"
	supp_bouton_BNE_niveau1 "La machine"
	supp_bouton_BNE_niveau1 "La mauvaise"
	supp_bouton_BNE_niveau2 "Le labyrinthe"
	supp_bouton_BNE_niveau1 "Les bidons"
	supp_bouton_BNE_niveau1 "Les châteaux"
	supp_bouton_BNE_niveau1 "Les intrus"
	supp_bouton_BNE_niveau1 "Les nombres"
	supp_bouton_BNE_niveau1 "Les poissons"
	supp_bouton_BNE_niveau1 "L'identique"
	supp_bouton_BNE_niveau1 "L'identique 2"
	supp_bouton_BNE_niveau1 "Memory"
	supp_bouton_BNE_niveau1 "Papillons"
	supp_bouton_BNE_niveau1 "Pavages"
	supp_bouton_BNE_niveau1 "Puzzles"
	supp_bouton_BNE_niveau1 "Boules"
	supp_bouton_BNE_niveau1 "Simple Paint"
	supp_bouton_BNE_niveau2 "Spirale,des nombres"
	supp_bouton_BNE_niveau2 "Spirale,visualiseur"
	supp_bouton_BNE_niveau1 "Suites logiques"
}


#************************************************
#Lancement du programme
#************************************************
echo "ATTENTION : la saisie du mot de passe, dans un terminal, se fait à l'aveugle -> aucun caractère n'apparait lors de la frappe du mot; une fois celui-ci saisi, appuyez sur la touche Entrée du clavier pour valider"
sudo apt-get install zenity
  	suppression_paquet_debian
	suppression_bouton_BNE
	if [  "`which zenity`" = "" ]; then
		echo Fin désinstallation 
	else
		zenity --info  --text "Fin de la désinstallation"
	fi
exit 0
