#!/bin/bash

#script écrit par Philippe Hénaff
#licence creatice commons CC BY-NC-SA 2.0 FR

type_environnement=${XDG_CURRENT_DESKTOP}
distrib_mint=$(lsb_release -sc)
distrib_mint=$(lsb_release -sc)
    case $distrib_mint in
        qiana)
            distrib_ubuntu="trusty "
            ;;
        rebecca)
            distrib_ubuntu="trusty "
            ;;
        rafaela)
            distrib_ubuntu="trusty "
            ;;
        rosa)
            distrib_ubuntu="trusty "
            ;;
        sarah)
            distrib_ubuntu="xenial"
            ;;
        serena)
            distrib_ubuntu="xenial"
            ;;
        sonya)
            distrib_ubuntu="xenial"
            ;;
        sylvia)
            distrib_ubuntu="xenial"
            ;;
        tara)
            distrib_ubuntu="bionic"
            ;;
        tina)
            distrib_ubuntu="bionic"
            ;;
       ulyana)
            distrib_ubuntu="focal"
            ;;
       ulyssa)
            distrib_ubuntu="focal"
            ;;
       uma)
            distrib_ubuntu="focal"
            ;;
       una)
            distrib_ubuntu="focal"
            ;;
        *)
            distrib_ubuntu=$(lsb_release -sc)
            ;;
    esac 


#################################################
#declaration des variables globales
#################################################
###### variables pour les entrees de niveau

niveau1_langue="29:1/niv1-langue.png,,Domaine de,la langue,"
niveau1_math="29:1/niv1-math.png,,Quantités et,nombres,"
niveau1_espace="29:1/niv1-espace.png,,Structuration de ,l'espace,"
niveau1_ordinateur="29:1/niv1-ordinateur.png,,Ordinateur,,"
niveau1_dessin="29:1/niv1-outils_dessin.png,,Outils de,dessin,"
niveau1_pluri="29:1/niv1-pluri_domaines.png,,Pluri-domaines,,"

niveau2_calcul="29:1/niv2-calcul.png,,Calcul,,"
niveau2_nombre="29:1/niv2-connaissance_nombres.png,,Connaissance,des nombres,"
niveau2_fraction="29:1/niv2-fraction.png,,Etude des,fractions,"
niveau2_probleme="29:1/niv2-probleme.png,,Situations,problèmes,"
niveau2_programmation="9:1/niv2-programmation.png,,Programmation,,"
niveau2_math_divers="29:1/niv2-math_divers.png,,MATH,Divers,"
niveau2_francais="29:1/niv2-francais.png,,Français,,"
niveau2_autres_domaines="29:1/niv2-divers.png,,Autres,Domaines,"
niveau2_pluri_domaines="29:1/niv2-pluri-domaines.png,,Pluri-domaines,,"

###### variables pour les fichiers
nom_fichier_params_niveau1="/usr/share/BNE-Linux/params/configNiveau1.rc"
nom_fichier_params_niveau1_sauve="/usr/share/BNE-Linux/params/sauve_config/configNiveau1.rc"
nom_fichier_params_niveau2="/usr/share/BNE-Linux/params/configNiveau2.rc"
nom_fichier_params_niveau2_sauve="/usr/share/BNE-Linux/params/sauve_config/configNiveau2.rc"

#################################################
#fonction test de la connexion internet
#################################################

verification_connexion_internet(){
	ping -q -c 2 www.google.fr >/dev/null 2>&1
	if [ $? -eq 0 ]; then # si connexion à Internet
		echo 1
	else
		echo -1
	fi
}

#################################################
#Fonction ajout entrees BNE
#################################################
# $1 -> chaine a trouver -> exemple : "29:1/pluri-domaine2.png,,Pluri-domaines,,"
# $2 -> chaine a ajouter courte  -> exemple : "GCompris"
# $3 -> chaine a ajouter -> exemple : "  39:2/gcompris.png,,GCompris,,/usr/games/gcompris"

ajout_BNE_niveau1(){
# TESTE PRESENCE DU FICHIER
	if [ -f "$nom_fichier_params_niveau1" ];then
		#SI PRESENCE FICHIER 
		if grep -q "$1" "$nom_fichier_params_niveau1" ; then
			# SI CHAINE TROUVEE, AJOUTE UNE LIGNE APRES CELLE-CI SEULEMENT SI ELLE N'EXISTE PAS DEJA
			value=$(grep -ic "$3" "$nom_fichier_params_niveau1")
			#teste la presence ou non de la chaine, retourne 0 si aucune correspondance
			if [ $value -eq 0 ]; then
				#syntaxe de base : sed -i.bak '/Ubuntu/a \Xubuntu' adresses.txt
				#syntaxe avec changement de delimitateur : sed -i.bak '\#Ubuntu#a \Xubuntu' adresses.txt
				sudo sed -i '\#'"$1"'#a \'"$3"'' "$nom_fichier_params_niveau1"
				sudo sed -i '\#'"$1"'#a \'"$3"'' "$nom_fichier_params_niveau1_sauve"
			fi
		else
			#SINON, AJOUTE LA CHAINE CHERCHEE EN FIN DE TEXTE
			sudo echo "$1" >> "$nom_fichier_params_niveau1"
			#ET AJOUTE LA CHAINE VOULUE APRES LA CHAINE RAJOUTEE
			sudo sed -i '\#'"$1"'#a \'"$3"'' "$nom_fichier_params_niveau1"
			sudo sed -i '\#'"$1"'#a \'"$3"'' "$nom_fichier_params_niveau1_sauve"
		fi
	fi
}
ajout_BNE_niveau2(){
# TESTE PRESENCE DU FICHIER
	if [ -f "$nom_fichier_params_niveau2" ];then
		#SI PRESENCE FICHIER 
		if grep -q "$1" "$nom_fichier_params_niveau2" ; then
			# SI CHAINE TROUVEE, AJOUTE UNE LIGNE APRES CELLE-CI SEULEMENT SI ELLE N'EXISTE PAS DEJA
			value=$(grep -ic "$3" "$nom_fichier_params_niveau2")
			#teste la presence ou non de la chaine, retourne 0 si aucune correspondance
			if [ $value -eq 0 ]; then
				#syntaxe de base : sed -i.bak '/Ubuntu/a \Xubuntu' adresses.txt
				#syntaxe avec changement de delimitateur : sed -i.bak '\#Ubuntu#a \Xubuntu' adresses.txt
				sudo sed -i '\#'"$1"'#a \'"$3"'' "$nom_fichier_params_niveau2"
				sudo sed -i '\#'"$1"'#a \'"$3"'' "$nom_fichier_params_niveau2_sauve"
			fi
		else
			#SINON, AJOUTE LA CHAINE CHERCHEE EN FIN DE TEXTE
			sudo echo "$1" >> "$nom_fichier_params_niveau2"
			#ET AJOUTE LA CHAINE VOULUE APRES LA CHAINE RAJOUTEE
			sudo sed -i '\#'"$1"'#a \'"$3"'' "$nom_fichier_params_niveau2"
			sudo sed -i '\#'"$1"'#a \'"$3"'' "$nom_fichier_params_niveau2_sauve"
		fi
	fi
}

#################################################
#Fonction test existence du binaire de lancement appli
#################################################
liste_applis="vide"
test_existence_logiciel(){
	# $1 -> nom du binaire
	chemin_lanceur_usr_bin="/usr/bin/""$1"
    chemin_lanceur_usr_sbin="/usr/sbin/""$1"
	chemin_lanceur_usr_games="/usr/games/""$1"
	chemin_lib="/usr/lib/adobe-flashplugin/""$1"
	# TESTE PRESENCE DU FICHIER
	if [ -f $chemin_lanceur_usr_bin ] || [ -f $chemin_lanceur_usr_games ] || [ -f $chemin_lib ] || [ -f $chemin_lanceur_usr_sbin ]  ;then
		echo "1"
	else
		if [ $liste_applis = "vide" ]; then
			liste_applis=" "
		fi
		liste_applis=$liste_applis$1"/"
		echo $liste_applis
	fi
}

#************************************************
#installation de wine
#************************************************

installation_wine(){
        existe=$(test_existence_logiciel wine)
	    if [ $existe != "1" ]; then
            sudo dpkg --add-architecture i386
            sudo wget -qO- https://dl.winehq.org/wine-builds/Release.key | sudo apt-key add -
            sudo apt-key adv --keyserver hkp://keyserver.ubuntu.com:80 --recv F987672F #force la reconnaissance de la clé

            sudo add-apt-repository --remove  'deb https://dl.winehq.org/wine-builds/ubuntu/ '$distrib_ubuntu' main'   # enlever toute trace dans les depot pour éviter doublons possible
            sudo apt-add-repository -y 'deb https://dl.winehq.org/wine-builds/ubuntu/ '$distrib_ubuntu' main'
            if [ $distrib_ubuntu = "bionic" ]; then
                wget -O- -q https://download.opensuse.org/repositories/Emulators:/Wine:/Debian/xUbuntu_18.04/Release.key | sudo apt-key add -
                sudo apt-add-repository -y 'deb https://download.opensuse.org/repositories/Emulators:/Wine:/Debian/xUbuntu_18.04/ ./'
            fi
            sudo apt-get update
            #sudo apt-key adv --keyserver hkp://keyserver.ubuntu.com:80 --recv F987672F
            sudo apt install -y --install-recommends winehq-stable
            winecfg
        fi
}

#************************************************
#installation du paquet DEBIAN
#************************************************
installation_paquet_debian(){
	sudo dpkg -i  Install_logiciels_gratuits/BNE-logiciels-gratuits.deb
	# donner les droits d'ecriture-lecture sur le dossier wine_apps
	sudo chmod -R 777 /usr/share/wine_apps
}

#************************************************
#installation des icones du BNE
#************************************************
installation_icones_BNE(){
	ajout_BNE_niveau2 "$niveau2_calcul"  "Abacalc" "  39:/usr/share/wine_apps/Abacalc/abacalc.png,,Abacalc,,wine /usr/share/wine_apps/Abacalc/abacalc.exe"
	ajout_BNE_niveau2 "$niveau2_francais"  "Abalect" "  39:/usr/share/wine_apps/abalect/Abalect/abalect.png,,Abalect,,wine /usr/share/wine_apps/abalect/Abalect/Abalect.exe"
	ajout_BNE_niveau1 "$niveau1_espace"  "A la bonne" "  39:/usr/share/wine_apps/GameFactory/bonneplace.png,,A la bonne,place,wine /usr/share/wine_apps/GameFactory/espace.exe"
	ajout_BNE_niveau1 "$niveau1_math"  "campagne" "  39:/usr/share/wine_apps/GameFactory/campagne.png,,A la campagne,,wine /usr/share/wine_apps/GameFactory/animaux2.exe"
	ajout_BNE_niveau1 "$niveau1_langue"  "A la poste" "  39:/usr/share/wine_apps/GameFactory/Alaposte.png,,A la poste,,wine /usr/share/wine_apps/GameFactory/intrus2.exe"
	ajout_BNE_niveau2 "$niveau2_calcul"  "AtouMath" "  39:/usr/share/wine_apps/VisualBasic/AtouMath.png,,AtouMath,,wine /usr/share/wine_apps/VisualBasic/AtouMath.exe"
	ajout_BNE_niveau1 "$niveau1_math"  "Au jardin" "  39:/usr/share/wine_apps/GameFactory/jardin.png,,Au jardin,,wine /usr/share/wine_apps/GameFactory/jardin.exe"
	ajout_BNE_niveau2 "$niveau2_calcul"  "Calcul" "  39:/usr/share/wine_apps/VisualBasic/Calcul.png,,Calcul,,wine /usr/share/wine_apps/VisualBasic/Calcul.exe"
	ajout_BNE_niveau2 "$niveau2_calcul"  "Calculatrice" "  39:/usr/share/wine_apps/GrandsEntiers/grandsentiers.png,,Calculatrice,de grands entiers,wine /usr/share/wine_apps/GrandsEntiers/GrandsEntiers.exe"
	ajout_BNE_niveau1 "$niveau1_ordinateur"  "Cursouris" "  39:/usr/share/wine_apps/GameFactory/cursouris.png,,Cursouris,,wine /usr/share/wine_apps/GameFactory/cursouri.exe"
	ajout_BNE_niveau2 "$niveau2_nombre"  "Décimo" "  39:/usr/share/wine_apps/GameFactory/decimo.png,,Décimo,,wine /usr/share/wine_apps/GameFactory/Decimo.exe"
	ajout_BNE_niveau1 "$niveau1_espace"  "Déplacements" "  39:/usr/share/wine_apps/GameFactory/deplacement.png,,Déplacements,sur un plan,wine /usr/share/wine_apps/GameFactory/DEPLPLAN.exe"
	ajout_BNE_niveau1 "$niveau1_math"  "Domino" "  39:/usr/share/wine_apps/VisualBasic/domino.png,,Domino,,wine /usr/share/wine_apps/VisualBasic/domino.exe"
	ajout_BNE_niveau1 "$niveau1_pluri"  "Double entrée" "  39:/usr/share/wine_apps/GameFactory/doubleentree.png,,Double entrée,,wine /usr/share/wine_apps/GameFactory/doubleen.exe"
	ajout_BNE_niveau2 "$niveau2_fraction"  "Fractions 1" "  39:/usr/share/wine_apps/GameFactory/fraction1.png,,Fractions 1,,wine /usr/share/wine_apps/GameFactory/Fractions.exe"
	ajout_BNE_niveau2 "$niveau2_fraction"  "Fractions 2" "  39:/usr/share/wine_apps/GameFactory/fraction2.png,,Fractions 2,,wine /usr/share/wine_apps/GameFactory/Fractions2.exe"
	ajout_BNE_niveau2 "$niveau2_nombre"  "Je compte" "  39:/usr/share/wine_apps/Euros/euros.png,,Je compte,mes p'tits sous,wine /usr/share/wine_apps/Euros/Euro.exe"
	ajout_BNE_niveau1 "$niveau1_espace"  "Labyrinthes" "  39:/usr/share/wine_apps/GameFactory/laby.png,,Labyrinthes,,wine /usr/share/wine_apps/GameFactory/labyrint.exe"
	ajout_BNE_niveau1 "$niveau1_langue"  "La machine" "  39:/usr/share/wine_apps/GameFactory/machine.png,,La machine,à écrire,wine /usr/share/wine_apps/GameFactory/machine3.exe"
	ajout_BNE_niveau1 "$niveau1_langue"  "La mauvaise" "  39:/usr/share/wine_apps/GameFactory/mauvaisepierre.png,,La mauvaise,pierre,wine /usr/share/wine_apps/GameFactory/intrus6.exe"
	ajout_BNE_niveau1 "$niveau1_langue"  "Les bidons" "  39:/usr/share/wine_apps/GameFactory/bidons.png,,Les bidons,,wine /usr/share/wine_apps/GameFactory/bidons.exe"
	ajout_BNE_niveau1 "$niveau1_espace"  "Les châteaux" "  39:/usr/share/wine_apps/GameFactory/chateau.png,,Les châteaux,,wine /usr/share/wine_apps/GameFactory/chateau.exe"
	ajout_BNE_niveau1 "$niveau1_langue"  "Les intrus" "  39:/usr/share/wine_apps/GameFactory/intrus.png,,Les intrus,,wine /usr/share/wine_apps/GameFactory/intrus.exe"
	ajout_BNE_niveau1 "$niveau1_math"  "Les nombres" "  39:/usr/share/wine_apps/GameFactory/nombre.png,,Les nombres,,wine /usr/share/wine_apps/GameFactory/cartes1.exe"
	ajout_BNE_niveau1 "$niveau1_espace"  "Les poissons" "  39:/usr/share/wine_apps/GameFactory/poisson.png,,Les poissons,,wine /usr/share/wine_apps/GameFactory/poissons.exe"
	ajout_BNE_niveau1 "$niveau1_langue"  "L'identique" "  39:/usr/share/wine_apps/GameFactory/identique.png,,L'identique,,wine /usr/share/wine_apps/GameFactory/leclone.exe"
	ajout_BNE_niveau1 "$niveau1_langue"  "L'identique 2" "  39:/usr/share/wine_apps/GameFactory/identique2.png,,L'identique 2,,wine /usr/share/wine_apps/GameFactory/leclone2.exe"
	ajout_BNE_niveau1 "$niveau1_langue"  "Memory" "  39:/usr/share/wine_apps/VisualBasic/MEMORY.png,,Memory,des lettres,wine /usr/share/wine_apps/VisualBasic/MEMORY.EXE"
	ajout_BNE_niveau1 "$niveau1_espace"  "Papillons" "  39:/usr/share/wine_apps/GameFactory/papillon.png,,Papillons,,wine /usr/share/wine_apps/GameFactory/papillon.exe"
	ajout_BNE_niveau1 "$niveau1_espace"  "Pavages" "  39:/usr/share/wine_apps/GameFactory/pavage.png,,Pavages,symétriques,wine /usr/share/wine_apps/GameFactory/pavage.exe"
	ajout_BNE_niveau1 "$niveau1_espace"  "Puzzles" "  39:/usr/share/wine_apps/GameFactory/puzzle.png,,Puzzles,,wine /usr/share/wine_apps/GameFactory/puzzle.exe"
	ajout_BNE_niveau1 "$niveau1_espace"  "Boules symétriques" "  39:/usr/share/wine_apps/GameFactory/boules.png,,Boules,symétriques,wine /usr/share/wine_apps/GameFactory/boules.exe"
	ajout_BNE_niveau1 "$niveau1_dessin"  "Simple Paint" "  39:/usr/share/wine_apps/SimplePaint/SimplePaint.png,,Simple Paint,,wine /usr/share/wine_apps/SimplePaint/SimplePaint.exe"
	ajout_BNE_niveau2 "$niveau2_nombre"  "Spirale,des nombres" "  39:/usr/share/wine_apps/spirale/spiralenombres.png,,Spirale,des nombres,wine /usr/share/wine_apps/spirale/Spiralenombres.exe"
	ajout_BNE_niveau2 "$niveau2_nombre"  "Spirale,visualiseur" "  39:/usr/share/wine_apps/spirale/spirale.png,,Spirale,visualiseur,wine /usr/share/wine_apps/spirale/Spirale.exe"
	ajout_BNE_niveau1 "$niveau1_pluri"  "Suites logiques" "  39:/usr/share/wine_apps/GameFactory/suite.png,,Suites logiques,,wine /usr/share/wine_apps/GameFactory/logique.exe"
}


#************************************************
#Lancement de l'installation
#************************************************

if [ -f "/usr/share/BNE-Linux/BNE-Linux.sh" ];then
	connexion=$(verification_connexion_internet)
	if [ $connexion = "1" ]; then # si connexion internet
		echo "ATTENTION : la saisie du mot de passe, dans un terminal, se fait à l'aveugle -> aucun caractère n'apparait lors de la frappe du mot; une fois celui-ci 	saisi, appuyez sur la touche Entrée du clavier pour valider"
		sudo apt-get update
		sudo apt-get install zenity
  		installation_wine
		installation_paquet_debian
		installation_icones_BNE
		if [  "`which zenity`" = "" ]; then
			echo "Fin de l'installation" 
		else
			zenity --info  --text "Fin de l'installation"
		fi
	else
		if [  "`which zenity`" != "" ]; then # si zenity installé
			zenity --info  --text "Aucun accès à Internet. Installation annulée."
			zenity --info  --text "Fin de l'installation"
		else
			echo "Aucun accès à Internet. Installation annulée."
			echo "Fin de l'installation"
		fi		
	fi
else
	if [  "`which zenity`" = "" ]; then
		echo "Le BNE-Linux n'est pas présent. Installation annulée"
		echo "Fin de l'installation"
	else
		zenity --info  --text "Le BNE-Linux n'est pas présent. Installation annulée"
		zenity --info  --text "Fin de l'installation"
	fi
fi
exit 0

